 
-- ----------------------------
-- Table structure for uni1_lottery
-- ----------------------------
DROP TABLE IF EXISTS `uni1_lottery`;
CREATE TABLE `uni1_lottery`  (
  `ID` int(11) NOT NULL,
  `user` varchar(255) CHARACTER SET latin1 COLLATE latin1_spanish_ci NOT NULL,
  `tickets` int(11) NULL DEFAULT 0
) ENGINE = MyISAM CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Table structure for uni1_lottery_config
-- ----------------------------
DROP TABLE IF EXISTS `uni1_lottery_config`;
CREATE TABLE `uni1_lottery_config`  (
  `max_ticket` int(11) NOT NULL DEFAULT 10,
  `time` int(11) NULL DEFAULT NULL,
  `winner` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '0',
  `price_metal` int(11) NOT NULL,
  `price_crystal` int(11) NOT NULL,
  `price_deuterium` int(11) NOT NULL,
  `price_mo` int(11) NOT NULL,
  `prem_mo` int(11) NOT NULL,
  `prem_crystal` int(11) NOT NULL,
  `prem_metal` int(11) NOT NULL,
  `prem_deuterium` int(11) NOT NULL,
  `descr` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `id` int(11) NOT NULL,
  `active` tinyint(1) NOT NULL DEFAULT 0,
  `regalo_mo` int(11) NOT NULL DEFAULT 5000,
  `cant_ganadores` int(11) NULL DEFAULT NULL,
  `percent_descuento` int(11) NOT NULL DEFAULT 10,
  `cant_horas` int(11) NOT NULL DEFAULT 72
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Compact;

-- ----------------------------
-- Records of uni1_lottery_config
-- ----------------------------
INSERT INTO `uni1_lottery_config` VALUES (10, 1591048817, 'closed', 5000, 4000, 3000, 5000, 1000, 0, 50, 50, 'Descripcion', 1, 1, 5000, 3, 10, 72);
